package apollo.gui.rna;

import java.util.ArrayList;
import java.util.Vector;

import apollo.datamodel.Comment;
import apollo.datamodel.CurationSet;
import apollo.datamodel.FeatureSet;
import apollo.datamodel.Range;
import apollo.datamodel.SeqFeature;
import apollo.datamodel.SequenceI;
import apollo.gui.synteny.CurationManager;


/**
 * Class which represents a RNA target in an interaction.
 */
public class Target
{
  // nucleotid i of the sequence is paired with the nucleotid 
  // interaction[i] of the target
  private int[] interaction; 
  // position of the target in the genome
  private int genomicStart; 
  // length of the target sequence
  private int length; 
  // strand where is the target
  private byte strand; 
  // name of the variable specific to the method
  private String methodVariableName;
  // value of the variable specific to the method
  private float methodVariableValue;
  // order order to the genomic start position
  private int genomicStartOrder;
  // order order to the value of the method variable
  private int methodVariableOrder; 
  private ArrayList genes; // list of overlapping genes
  private SeqFeature previousGene; // gene previous the target
  private SeqFeature nextGene; // gene next the target
  private float rnafoldFreeEnergy; // free energy generated by RNAfold

  // class variables
  public static char GC_SYMBOL = '|';
  public static char AU_SYMBOL = '|';
  public static char GU_SYMBOL = ':';
  public static char GA_SYMBOL = ' ';
  public static char OTHER_SYMBOL = ' ';

  public static final byte STRAND_PLUS = 1;
  public static final byte STRAND_MINUS = -1;

  public Target()
  {
  }

  /**
   * Builder
   * 
   * @param interaction   Interaction between a sequence, and this target
   * @param genomicStart  Start position of the taregt on the genomic sequence
   * @param length        Length of the target sequence
   * @param strand        Strand on the target
   */
  public Target(int[] interaction, int genomicStart, int length, byte strand)
  {
    super();
    this.interaction        = interaction;
    this.genomicStart       = genomicStart;
    this.length             = length;
    this.strand             = strand;
    this.genes              = new ArrayList();
    this.previousGene       = null;
    this.nextGene           = null;
    this.rnafoldFreeEnergy = Float.NEGATIVE_INFINITY;
  }

  /**
   * Builder
   * 
   * @param interaction   Interaction between a sequence, and this target
   * @param genomicStart  Start position of the taregt on the genomic sequence
   * @param length        Length of the target sequence
   * @param strand        Strand on the target
   * @param variableName  Name of the method variable
   * @param variableValue Value of the method variable
   */
  public Target(int[] interaction, int genomicStart, int length, byte strand,
      String variableName, float variableValue)
  {
    super();
    this.interaction          = interaction;
    this.genomicStart         = genomicStart;
    this.length               = length;
    this.strand               = strand;
    this.methodVariableName   = variableName;
    this.methodVariableValue  = variableValue;
    this.genes                = new ArrayList();
    this.previousGene         = null;
    this.nextGene             = null;
    this.rnafoldFreeEnergy    = Float.NEGATIVE_INFINITY;
  }

  /**
   * Set the name and the value of the method variable
   * 
   * @param variableName  Name of the method variable
   * @param variableValue Value of the method variable
   */
  public void setMethodVariable(String variableName, float variableValue)
  {
    this.methodVariableName   = variableName;
    this.methodVariableValue = variableValue;
  }

  /**
   * Return the value of the variable of the method
   * 
   * @return The value of the variable of the method
   */
  public float getMethodVariableValue()
  {
    return methodVariableValue;
  }

  /**
   * Return the order of the target according to the value of the method
   * variable
   * 
   * @return The order of the target according to the value of the method
   *         variable
   */
  public int getMethodVariableOrder()
  {
    return methodVariableOrder;
  }

  /**
   * Set the order of the target according to the value of the method variable
   * 
   * @param methodVariableOrder The order of the target according to the value
   *          of the method variable
   */
  public void setMethodVariableOrder(int methodVariableOrder)
  {
    this.methodVariableOrder = methodVariableOrder;
  }

  /**
   * Set the value of the method variable
   * 
   * @param methodVariableValue The value of the method variable
   */
  public void setMethodVariableValue(float methodVariableValue)
  {
    this.methodVariableValue = methodVariableValue;
  }

  /**
   * Get the order of the target according to the genomic start position
   * 
   * @return The order of the target according to the genomic start position
   */
  public int getGenomicStartOrder()
  {
    return genomicStartOrder;
  }

  /**
   * Set the order of the target according to the genomic start position
   * 
   * @param genomicStartOrder The order of the target according to the genomic
   *          start position
   */
  public void setGenomicStartOrder(int genomicStartOrder)
  {
    this.genomicStartOrder = genomicStartOrder;
  }

  /**
   * Return genomic start position
   * 
   * @return Genomic start position
   */
  public int getGenomicStart()
  {
    return genomicStart;
  }

  /**
   * Set genomic start position
   * 
   * @param genomicStart Genomic start position
   */
  public void setGenomicStart(int genomicStart)
  {
    this.genomicStart = genomicStart;
  }

  /**
   * Return length of the target
   * 
   * @return Length of the target
   */
  public int getLength()
  {
    return length;
  }

  /**
   * Return strand of the target
   * 
   * @return Strand of the target
   */
  public byte getStrand()
  {
    return strand;
  }

  /**
   * Return name of the method variable
   * 
   * @return Name of the method variable
   */
  public String getMethodVariableName()
  {
    return methodVariableName;
  }

  /**
   * Return interaction array
   * 
   * @return Interaction array
   */
  public int[] getInteraction()
  {
    return interaction;
  }

  /**
   * Return the gene at the position index in the list
   * 
   * @param index Index of the gene in the list
   * @return      The gene at the position index in the list
   */
  public SeqFeature getGene(int index)
  {
    return ((SeqFeature) genes.get(index));
  }

  /**
   * Return the list of the genes which overlaps the target
   * 
   * @return The list of the overlapping genes
   */
  public ArrayList getGenes()
  {
    return genes;
  }

  /**
   * Return The gene which follows the target
   * 
   * @return The gene which follows the target
   */
  public SeqFeature getNextGene()
  {
    return nextGene;
  }

  /**
   * Return The gene which precedes the target
   * 
   * @return The gene which precedes the target
   */
  public SeqFeature getPreviousGene()
  {
    return previousGene;
  }

  /**
   * Return a string composed of the names of the genes overlapping the target
   * 
   * @return A string composed of the names of the genes overlapping the target
   */
  public String getGenesName()
  {
    String genesName = new String();

    if (genes.size() >= 1) {
      genesName = getGene(0).getName();
      for (int i = 1; i < genes.size(); i++) {
        genesName = genesName.concat(";" + getGene(i).getName());
      }
    }
    return genesName;
  }

  /**
   * Return a string containing the start position of the genes overlapping the
   * target
   * 
   * @return A string containing the start position of the genes overlapping the
   *         target
   */
  public String getGenesPosition()
  {
    String genesPosition = new String();

    if (genes.size() >= 1) {
      genesPosition = String.valueOf(getGene(0).getLow());
      for (int i = 1; i < genes.size(); i++) {
        genesPosition = genesPosition.concat(";" + getGene(i).getLow());
      }
    }
    return genesPosition;
  }

  /**
   * Return the free energy computed by RNAfold
   * 
   * @return Free energy computed by RNAfold
   */
  public float getRNAfoldFreeEnergy()
  {
    return rnafoldFreeEnergy;
  }

  /**
   * Set free energy of the interaction
   * 
   * @param freeEnergy Free energy of the interaction
   */
  public void setRNAfoldFreeEnergy(float freeEnergy)
  {
    this.rnafoldFreeEnergy = freeEnergy;
  }

  /**
   * Return the strand in a string format
   * 
   * @return The string "+" or "-" according to the value of the strand
   */
  public String drawStrand()
  {
    String strandDisplay;
    if (strand == STRAND_PLUS) {
      strandDisplay = "+";
    }
    else {
      strandDisplay = "-";
    }
    return strandDisplay;
  }

  /**
   * Search and return the nucleotidic sequence of the target
   * 
   * @return The nucleotidic sequence of the target
   */
  public String getSequence()
  {
    SequenceI genomicSeq = CurationManager.getCurationManager()
        .getActiveCurState().getCurationSet().getRefSequence();
    int start, stop;

    if (strand > 0) {
      start = genomicStart;
      stop  = genomicStart + length - 1;
    }
    else {
      start = genomicStart + length - 1;
      stop  = genomicStart;
    }
    return (genomicSeq.getResidues(start, stop));
  }

  /**
   * Compute the interaction visualization. create three string, to represent
   * interaction in a specific format
   * 
   * @param initialSeq  Initial sequence implied in the interaction
   * @return            Three strings representing the interaction
   */
  public String[] getInteractionView(String initialSeq)
  {
    return getInteractionView(initialSeq, this.getSequence(), interaction);
  }

  /**
   * Compute the interaction visualization. create three string, to represent
   * interaction in a specific format First string is the initial sequence,
   * Second String represents pairs between the two sequences with symbols:
   * Symbol Pair '|' GC ':' AU '.' GU Third string is the target sequence
   * Example of output strings: 5' AAGCCGU-- 3' :: || 3' UUUAGCUUU 5'
   * 
   * @param initialSeq  Initial sequence implied in the interaction
   * @param targetSeq   Target sequence implied in the interaction
   * @param interaction Integer array, representing the interaction
   * @return            Three strings representing the interaction
   */
  public String[] getInteractionView(String initialSeq, String targetSeq,
      int[] interaction)
  {
    String[] viewStrings = new String[3];
    int nPairs = 0, iNextPair = 0;
    int iSource = initialSeq.length() - 1, iTarget = 0;

    String seq1 = "5'";
    String seq2 = "3'";
    String link = "  ";

    // compute the number of pairs in the interaction
    for (int i = 0; i < interaction.length; i++) {
      if (interaction[i] != -1) {
        nPairs++;
      }
    }

    // creation of two arrays, which contain the number of paired
    // nucleotids respectively in the source (target) sequence
    int[] pairsInSource = new int[nPairs];
    int[] pairsInTarget = new int[nPairs];
    for (int i = interaction.length - 1; i >= 0; i--) {
      if (interaction[i] > -1) {
        pairsInSource[iNextPair] = i;
        pairsInTarget[iNextPair] = interaction[i];
        iNextPair++;
      }
    }
    // for each pair
    for (int i = 0; i < nPairs; i++) {
      boolean isFinished = false;
      while (isFinished == false) {
        if (iTarget < pairsInTarget[i]) {
          seq1 = seq1.concat(targetSeq.substring(iTarget, iTarget + 1));
          link = link.concat(" ");
          iTarget++;
          if (iSource > pairsInSource[i]) {
            seq2 = seq2.concat(initialSeq.substring(iSource, iSource + 1));
            iSource--;
          }
          else {
            seq2 = seq2.concat("-");
          }
        }
        else {
          seq2 = seq2.concat(initialSeq.substring(iSource, iSource + 1));

          if (iSource > pairsInSource[i]) {
            seq1 = seq1.concat("-");
            link = link.concat(" ");
          }
          else {
            seq1 = seq1.concat(targetSeq.substring(iTarget, iTarget + 1));
            link = link.concat(getSymbol(targetSeq.charAt(iTarget), initialSeq
                .charAt(iSource)));
            iTarget++;
            isFinished = true;
          }
          iSource--;
        }
      }
    }
    // complete string with nucleotids unpairs at the end
    while ((iTarget <= targetSeq.length() - 1) || (iSource >= 0)) {
      link = link.concat(" ");
      if (iTarget <= targetSeq.length() - 1) {
        seq1 = seq1.concat(targetSeq.substring(iTarget, iTarget + 1));
        iTarget++;
      }
      else {
        seq1 = seq1.concat("-");
      }
      if (iSource >= 0) {
        seq2 = seq2.concat(initialSeq.substring(iSource, iSource + 1));
        iSource--;
      }
      else {
        seq2 = seq2.concat("-");
      }
    }
    viewStrings[0] = seq1.concat(" 3'\n");
    viewStrings[2] = seq2.concat(" 5'");
    viewStrings[1] = link.concat("   \n");
    return viewStrings;
  }

  /**
   * Search the symbol to represent a pair between two nucleotids
   * 
   * @param nt1 Character representing a nucleotid
   * @param nt2 Character representing a nucleotid
   * @return    Symbol to represent a pair between nt1 and nt2
   */
  private String getSymbol(char nt1, char nt2)
  {
    String symbol;
    if (((nt1 == 'G') && (nt2 == 'C')) || ((nt1 == 'C') && (nt2 == 'G'))) {
      symbol = String.valueOf(GC_SYMBOL);
    }
    else if (((nt1 == 'A') && (nt2 == 'T')) || ((nt1 == 'T') && (nt2 == 'A'))) {
      symbol = String.valueOf(AU_SYMBOL);
    }
    else if (((nt1 == 'G') && (nt2 == 'T')) || ((nt1 == 'T') && (nt2 == 'G'))) {
      symbol = String.valueOf(GU_SYMBOL);
    }
    else if (((nt1 == 'G') && (nt2 == 'A')) || ((nt1 == 'G') && (nt2 == 'A'))) {
      symbol = String.valueOf(GA_SYMBOL);
    }
    else {
      symbol = String.valueOf(OTHER_SYMBOL);
    }
    return symbol;
  }

  /**
   * Search neighbor genes of the target. Note: in circular genome, some genes
   * starts before the end of the genome and finish after the start of the
   * genome. In Apollo, these genes have the same positions that the genomic
   * sequence so there are not scan.
   */
  public void neighborSearch()
  {
    CurationSet curationSet = CurationManager.getCurationManager()
        .getActiveCurState().getCurationSet();
    // set of features
    FeatureSet featSet = (FeatureSet) curationSet.getAnnots();
    // a feature of the list of features
    SeqFeature feature; 
    /// Range of the genomic sequence
    Range genomeRange = (Range) curationSet.getRefSequence().getRange(); 

    int genomicStop   = genomicStart + length - 1; // stop position of the target
    int iPreviousGene = -1; // index of the previous gene
    int iNextGene     = -1; // index of the next gene
    int highPosition  = 0; // high position of the previous gene
    int lowPosition   = featSet.getHigh(); // low position of the next gene

    for (int i = 0; i < featSet.size(); i++) {
      feature = (SeqFeature) featSet.getFeatureAt(i);
      // if the feature is a gene and that it's not a particular case
      if ( (feature.getFeatureType().compareTo("gene") == 0)
          && (!((feature.getLow()  == genomeRange.getLow()) && 
                (feature.getHigh() == genomeRange.getHigh()))) ) {
        // if the gene overlaps the target
        if (   (feature.getLow()  <= genomicStop)
            && (feature.getHigh() >= genomicStart)) {
          genes.add(feature);
        } // if the feature precedes the target and is closer
        else if ((feature.getHigh() < genomicStart)
            &&   (feature.getHigh() > highPosition)) {
          iPreviousGene = i;
          highPosition  = feature.getHigh();
        } // if the feature follows the target and is closer
        else if ((feature.getLow() > genomicStop)
            &&   (feature.getLow() < lowPosition)) {
          iNextGene   = i;
          lowPosition = feature.getLow();
        }
      }
    }

    // set the previous and next genes
    if (iPreviousGene > -1) {
      previousGene = (SeqFeature) featSet.getFeatureAt(iPreviousGene);
    }
    if (iNextGene > -1) {
      nextGene = (SeqFeature) featSet.getFeatureAt(iNextGene);
    }
  }

  /**
   * Return the length of the part of the target which is paired
   * 
   * @return The length of the part of the target which is paired
   */
  public int getInteractionLength()
  {
    int iFirst  = 1000; // index of the first paired nucleotid in the target
    int iLast   = 1000; // index of the last paired nucleotid in the target

    boolean isFound = false;

    for (int i = 0; i < interaction.length; i++) {
      if (interaction[i] != -1) {
        if (isFound == true) {
          iLast = interaction[i];
        }
        else {
          iFirst = interaction[i];
          isFound = true;
        }
      }
    }
    return (iFirst - iLast + 1);
  }

  /**
   * Return genomic stop position of the target
   * 
   * @return Genomic stop position of the target
   */
  public int getGenomicStop()
  {
    return (genomicStart + length - 1);
  }

  /**
   * Return the distance between the overlapping gene and the previous gene If
   * there is no overlapping gene or if there is no previous gene, return -1 If
   * the two genes are overlapping, return 0.
   * 
   * @return The distance between the overlapping gene and the previous gene
   */
  public int getPreviousDistance()
  {
    int distance = -1;
    int lowPosition; // lowest position between the overlapping genes

    // if there is overlapping gene and a previous gene
    if ((genes.size() > 0) && (previousGene != null)) {
      lowPosition = ((SeqFeature) genes.get(0)).getLow(); // initialize low
                                                          // position
      // look for the lowest positions between the found overlapping genes
      for (int i = 1; i < genes.size(); i++) {
        if (((SeqFeature) genes.get(i)).getLow() < lowPosition) {
          lowPosition = ((SeqFeature) genes.get(i)).getLow();
        }
      }
      // compute the distance
      distance = Math.max(lowPosition - previousGene.getHigh() - 1, 0);
    }
    return distance;
  }

  /**
   * Return the distance between the overlapping gene and the next gene. If
   * there is no overlapping gene or if there is no next gene, return -1 If the
   * two genes are overlapping, return 0.
   * 
   * @return The distance between the overlapping gene and the next gene
   */
  public int getNextDistance()
  {
    int distance = -1;
    int highPosition; // highest position between the overlapping genes

    // if there is overlapping gene and a next gene
    if ((genes.size() > 0) && (nextGene != null)) {
      highPosition = ((SeqFeature) genes.get(0)).getHigh(); // initalize high
                                                            // position
      // look for the highest positions between the found overlapping genes
      for (int i = 1; i < genes.size(); i++) {
        if (((SeqFeature) genes.get(i)).getHigh() > highPosition) {
          highPosition = ((SeqFeature) genes.get(i)).getHigh();
        }
      }
      distance = Math.max(nextGene.getLow() - highPosition - 1, 0);
    }
    return distance;
  }

  /**
   * Return a string composed of symbols representing : the strand of the
   * previous gene, the overlapping gene(s) and the next gene. The symbol > is
   * used to represent the strand plus and the symbol < for the strand minus
   * 
   * @return A string composed of symbols representing the strands of the genes.
   */
  public String getSymbols()
  {
    String symbols = new String();
    if (previousGene != null) {
      symbols = getSymbol(previousGene.getStrand());
    }
    else {
      symbols = ".";
    }
    // for each gene overlapping the target
    if (genes.size() > 0) {
      for (int i = 0; i < genes.size(); i++) {
        symbols = symbols.concat(getSymbol(((SeqFeature) genes.get(i))
            .getStrand()));
      }
    }
    else {
      symbols = symbols.concat(".");
    }
    if (nextGene != null) {
      symbols = symbols.concat(getSymbol(nextGene.getStrand()));
    }
    else {
      symbols = symbols.concat(".");
    }
    return symbols;
  }

  /**
   * Return the symbol associated to the strand: < (for strand minus) or > (for
   * strand plus)
   * 
   * @param strand  A strand
   * @return        The symbol associated to the strand
   */
  public static String getSymbol(int strand)
  {
    String symbol = "<";
    if (strand == STRAND_PLUS) {
      symbol = ">";
    }
    return symbol;
  }

  /**
   * Compute and return a string which describes the target sequence: The string
   * is composed of its name, its genomic positions, if the sequence is on the
   * reverse strand and of the names of the genes which overlap it.
   * 
   * @return String which describes the target
   */
  public String getName()
  {
    // 
    String revStrand = ""; // contains text if the target is on the reverse
                            // strand
    if (strand == STRAND_MINUS) {
      revStrand = " (reverse strand)";
    }

    // get the reference sequence
    SequenceI refSeq = CurationManager.getCurationManager().getActiveCurState()
        .getCurationSet().getRefSequence();

    // add the name of the reference sequence, revStrand string, and the genomic
    // positions
    String seqName = (refSeq.getName() + revStrand + " from "
        + getGenomicStart() + " to " + getGenomicStop());

    // add the names of the genes which overlap the target
    if (getGenesName().compareTo("") != 0) {
      seqName = seqName
          .concat(" (overlapping gene(s): " + getGenesName() + ")");
    }

    return seqName;
  }

  /**
   * Return A string composed of the names of overlapping gene transcripts and
   * if the name contains 'Hypothetical protein', the associated notes.
   * 
   * @return The names of the transcripts of the overlapping genes
   */
  public String getGeneTranscripts()
  {
    // description of all the transcripts of all the genes
    String genesTranscriptsDesc = new String(); 
    // description of one gene 
    String geneDesc = new String(); 
    SeqFeature  gene;
    SeqFeature  transcript;
    Vector      comments;
    Comment     comment;

    // for each overlapping gene
    for (int i = 0; i < genes.size(); i++) {
      gene      = (SeqFeature) genes.get(i);
      geneDesc  = "";
      
      if (i > 0) {
        genesTranscriptsDesc = genesTranscriptsDesc.concat(";");
      }
      
      // for each feature of the gene
      for (int j = 0; j < gene.getFeatures().size(); j++) {
        transcript = (SeqFeature) gene.getFeatureAt(j);

        // if the feature is a transcript, add its name in the string
        if (transcript.getFeatureType().compareTo("transcript") == 0) {
          if (j > 0) {
            geneDesc = geneDesc.concat(", ");
          }
          geneDesc = geneDesc.concat(transcript.getName());

          // if the name contains the string 'ypothetical protein', add the comments 
          // (field "Notes" in the genbank file)
          if (transcript.getName().matches("(.*ypothetical protein.*)") == true) {
            comments = transcript.getAnnotatedFeature().getComments();
            for (int k = 0; k < comments.size(); k++) {
              comment = (Comment) comments.elementAt(k);
              if (!comment.getText().equals("")) {
                geneDesc = geneDesc.concat("(" + comment.getText()
                    + ")");
              }
            }
          }
        }
      }
      if (geneDesc.compareTo("") == 0) {
        genesTranscriptsDesc = genesTranscriptsDesc.concat("-");
      } 
      else {
        genesTranscriptsDesc = genesTranscriptsDesc.concat(geneDesc);
      }
    }
    return genesTranscriptsDesc;
  }
}
